

#include "basic_system_compiler_directives.h"

#include "/home/jonatan/robocup/v2/evolve/genTypes.h"



typedef std::vector <PlayerObject> PVector;

const int preds_start = (int)_StartCommonPredicates+1;
const int preds_stop  = (int)_EndMovePredicates-1;

class ViewManager;
class GameView;
class BallView;
class AgentView;
class PlayerView;

class TeamDecision : public Decision {
public:
  TeamDecision(ActuatorInterface* const actuator_interface = NULL);
  virtual ~TeamDecision();

  virtual ServerCommand* initAgent();
  virtual bool start();

  // Event handlers
  //virtual void onActuatorSensorData();
  virtual void onAuralCoachSensorData();
  virtual void onAuralRefereeSensorData();
  virtual void onAuralPlayerSensorData();
  virtual void onAuralSelfSensorData();
  virtual void onInit();
  //virtual void onPhysicalSensorData();
  //virtual void onVisualSensorData();

  //virtual void onBeforeSensorData();
  //virtual void onAfterSensorData();
  //virtual void onBeforeTick();
  //virtual void onAfterTick();

  //virtual void onNewCycle(const bool forced);
  //virtual bool onEstimatedNewCycle(UInt16 estimated_time, UInt16 ticks);
  virtual void onCommandWarning();

protected:
  ViewManager* const viewManager;
  const WorldModelInterface* const worldModelInterface;
  const WorldFacts *facts;
  GameView* gameView;
  BallView* ballView;
  AgentView* agentView;
  PlayerView* playerView;

  FindBall findBall;  
  GotoBall gotoBall;
  ReceivePass receivePass;
  Dribble dribble;
  Score score;
  BeckhamPass beckhamPass;
  //GoaliePositioning goaliePositioning;
  //CatchBall catchBall;
  //FreeKick freeKick;

  int playernumber;  // Uniform Number
  char side;         // Our Side - 'l' or 'r'
  int passtome;      // Cycles left to intercept the ball if someone passed me
  PlayMode lastMode; 
  ServerCommand* dummyCommand;
  ServerCommand* waitCommand;

  // Decision making not based on the gentic stuff
  virtual void decide();
  virtual void decide_kickoff();
  virtual void decide_freekick();
  virtual void decideNoAction();
  virtual void decideWait();
  virtual void teleportToInitialPosition(int state);

  // Gen Stuff
  int invnumber; // number in the current population
  Fitness fitness;
  char fitness_filename[10];
  Position ppos[3001];
  int lastKickTime;
  dTree *dMove;
  dTree *dKick;
  Actions currentAction;
  int currentlyPersistent;
  ServerCommand *persistentCmd;
  int *preds;
  virtual void initGen();
  virtual void exitGen();
  virtual bool pred(Predicates p);
  virtual void setCurrentAction(Actions a);
  virtual void preformAction();
  virtual bool persistent();
  virtual void genDecide(const TreeType treeType);
};



