// decisionTree.h: interface for the decisionTree class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(DECISIONTREE_H)
#define DECISIONTREE_H

//#if _MSC_VER > 1000
//#pragma once
//#endif // _MSC_VER > 1000

#include "genTypes.h"
#include "Log.h"
#include <fstream.h>

#define INITIAL_SIZE 200
#define INC_SIZE 50

const long logArea = 1;

class DecisionTree  
{
public:
	void mutate();
	void _test();
	void reduce();
	int depth(int pos);
	void insert(DecisionTree *t, int pos);
	DecisionTree* cloneSubTree(int pos);
	int nNodes();
	DecisionTree** crossover(DecisionTree* t);
	DecisionTree* clone();
	void print(ofstream *f);
	void reset();
	DecisionTree(Log *log, TreeType type, int seed);
	DecisionTree(Log *log, TreeType type, int nEntries, int seed);
	virtual ~DecisionTree();
	// ---
	bool createRandomSubTree(int depth, int minDepth, int maxDepth, int pos, enum NodeType type);
	int  getUnusedIndex();	
	void print();
	void load(ifstream *f);
	void save(ofstream *f);
	dTree *tree;
	int getPos(int no);


private:
	int maxInt(int v1, int v2) { return v1>v2?v1:v2; }
	int minInt(int v1, int v2) { return v1<v2?v1:v2; }
	// Variables
	Log *log;
	int maxEntries;
	int maxDepth;
	TreeType treeType;
	// Methods
	int  randInt(int min, int max);
	bool randBool();
	NodeID randID(NodeType type);
	const char* convertID2Str(NodeType type, NodeID id);
	void deleteSubTree(int pos);
	void print(int pos, int *param, ofstream *f);
	void _cloneSubTree(int pos, bool *used);
};

#endif
