// generation.h: interface for the generation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined (GENERATION_H)
#define GENERATION_H

#include "DecisionTree1.h"	// Added by ClassView
//#if _MSC_VER > 1000
//#pragma once
//#endif // _MSC_VER > 1000

#include "genTypes.h"

class Generation  
{
public:
	bool randP(float p);
	void reset();
	void save(char *filename);
	bool load(char *filename);
	//
	Generation(Log *log, int generation);
	virtual ~Generation();
	//
	Log *log;
	DecisionTree *moveTree[POPULATION_SIZE];
	DecisionTree *kickTree[POPULATION_SIZE];
	float fitness[POPULATION_SIZE];
	int rank[POPULATION_SIZE];
	int inv_rank[POPULATION_SIZE+1];
	int generation;
	bool stats;
	//
	int select();
	Generation* evolve();
	void loadStats(const char *filename);
	void print(char *filename);
	void createNewPopulation(int minKickTreeSize, int maxKickTreeSize, int minMoveTreeSize, int maxMoveTreeSize);
};

#endif // !defined(GENERATION_H)
