#ifndef FITNESS_H
#define FITNESS_H

const float OPEN_DISTANCE = 10.0;

typedef struct _FitData {
  short inv;
  short myScore;
  short ourScore;
  short theirScore;
  short kicks;
  short passes;
  short scoringShoots;
  short avg_dis_to_ball;
  short avg_y;
  short per_cent_open;
  short offensive_time;
} FitData;

typedef struct _Weigth {
  float won;
  float team_goal;
  float goal;
  float shoot;
  float kick;
  float pass;
  float active;
  float calc(FitData d) { 
    float f=won*(d.ourScore>d.theirScore?1:0);
    f += team_goal*(d.ourScore-d.theirScore);
    f += goal*d.myScore+(shoot-goal)*d.scoringShoots;
    f += kick*d.kicks+pass*d.passes;
    f += (d.kicks>0)?active:0;
    return f;
  }
} Weigth;

Weigth w = {200.0,100.0,0.0,200.0,30.0,100.0,200.0};

const char MATCHLOG[]="match_stats.txt";
const char POPSTATS[]="population_stats.txt";
const char RAWPOPSTATS[]="raw_population_stats.txt";
const char INTERFILE[]="inter_fitness.dat";
const char fitfilel[][7] = {
  "l1.fit",
  "l2.fit",
  "l3.fit",
  "l4.fit",
  "l5.fit",
  "l6.fit",
  "l7.fit",
  "l8.fit",
  "l9.fit",
  "la.fit",
  "lb.fit" };
const char fitfiler[][7] = {
  "r1.fit",
  "r2.fit",
  "r3.fit",
  "r4.fit",
  "r5.fit",
  "r6.fit",
  "r7.fit",
  "r8.fit",
  "r9.fit",
  "ra.fit",
  "rb.fit" };
const char posfilel[][7] = {
  "l1.pos",
  "l2.pos",
  "l3.pos",
  "l4.pos",
  "l5.pos",
  "l6.pos",
  "l7.pos",
  "l8.pos",
  "l9.pos",
  "la.pos",
  "lb.pos" };
const char posfiler[][7] = {
  "r1.pos",
  "r2.pos",
  "r3.pos",
  "r4.pos",
  "r5.pos",
  "r6.pos",
  "r7.pos",
  "r8.pos",
  "r9.pos",
  "ra.pos",
  "rb.pos" };

#endif // !FITNESS_H
