#ifndef TEAMDECISION_H
#define TEAMDECISION_H


#include "basic_system_compiler_directives.h"
#include "Decision.h"
#include "WorldModelInterface.h"
#include "FindBall.h"
//#include "MoveToPosition.h"
#include "GotoBall.h"
#include "GoaliePositioning.h"
#include "CatchBall.h"

RS_BEGIN_NAMESPACE

class ViewManager;
class GameView;
class BallView;
class AgentView;
class PlayerView;

class TeamDecision : public Decision {
public:
  TeamDecision(ActuatorInterface* const actuator_interface = NULL);
  virtual ~TeamDecision();

  virtual ServerCommand* initAgent();
  virtual bool start();
  virtual bool decide();
  virtual bool decide_freekick();
  virtual void decideNoAction();
  virtual void initialPositioning(int state);
  virtual bool alignBody1(AngleDeg ad);

  // Event handlers
  //virtual void onActuatorSensorData();
  virtual void onAuralCoachSensorData();
  virtual void onAuralRefereeSensorData();
  virtual void onAuralPlayerSensorData();
  virtual void onAuralSelfSensorData();
  virtual void onInit();
  //virtual void onPhysicalSensorData();
  //virtual void onVisualSensorData();

  //virtual void onBeforeSensorData();
  //virtual void onAfterSensorData();
  //virtual void onBeforeTick();
  //virtual void onAfterTick();

  //virtual void onNewCycle(const bool forced);
  //virtual bool onEstimatedNewCycle(UInt16 estimated_time, UInt16 ticks);
  virtual void onCommandWarning();

protected:
  ViewManager* const viewManager;
  const WorldModelInterface* const worldModelInterface;
  const WorldFacts *facts;
  GameView* gameView;
  BallView* ballView;
  AgentView* agentView;
  PlayerView* playerView;
  AngleDeg dirToCenter;
  bool ballIsKnown; 
  Point current_bp; //current ball point
  int ballobs;      //ball last observed
  char side;

  //Skills
  GotoBall gotoBall;
  FindBall findBall;
  //MoveToPosition moveToPosition;
  GoaliePositioning goaliePositioning;
  CatchBall catchBall;
};


RS_END_NAMESPACE


#endif // !TEAMDECISION_H
