#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "scconst.h"
#include "/home/jonatan/robocup/v2/exp/aut.h"

#define DATE      "$(date +%y%m%d-%H%M:%S) "
#define LOG(x)    f<<"echo "<<DATE<<"\""<<x<<"\" >>"<<logfile<<endl;
#define LOGCMD(x) f<<"echo -n "<<DATE<<" >>"<<logfile<<endl; f<<" "<<x<<" >>"<<logfile<<endl;

ofstream f;

void log(char* s) {
  //f<<"echo \""<<s<<"\" >>"<<logfile<<endl;
  LOG(s);
}

void log(char* s, int n) {
  //f<<"echo \""<<s<<n<<"\" >>"<<logfile<<endl;
  LOG(s<<n);
}

void log(char* s1, char* s2, char* s3, char* s4) {
  //f<<"echo \""<<s1<<s2<<s3<<s4<<"\" >>"<<logfile<<endl;
  LOG(s1<<s2<<s3<<s4);
}

char dec2hex(int n, int i) {
  char h[] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
  int v = 1;
  while (i>0) {
    v *= 16;
    --i;
  }
  v = (n/v)%16;
  return h[v];
}

int randInt() {
  return rand()%nOfPlayers;
}

void teamname(char* str, int n, int* a) {
  int i;
  //str[0] = dec2hex(n,0);
  for (i=0; i<n; ++i) {
    str[i*2+0] = dec2hex(a[i],1);
    str[i*2+1] = dec2hex(a[i],0);
  }
  str[n*2]=0;
}

void match(int n, int* a, int no) {
  char name1[30], name2[30];
  int c = n/2;
  teamname(name1,c,a);
  teamname(name2,c,&a[c]);
  f<<"match "<<name1<<" "<<name2<<" "<<no<<endl;
}

void tournament() {
  log("Let the tournament begin!");
  int k,l,i,j;
  bool ok;
  const int n=nOfPlayers;
  const int m=n*nOfGamesPerPlayer/(2*teamSize);
  int a[m][2*teamSize];
  int g[n];
  bool u[n];
  do {
    //cout<<m<<"-------------------------\n";
    ok=true;
    for (j=0; j<n; ++j)
      g[j]=0;
    for (i=0; i<m; ++i) {
      for (j=0; j<n; ++j)
	u[j]=false;
      k=0;
      for (l=0; l<n; ++l) 
	if (g[l]<nOfGamesPerPlayer) 
	  k++;
      if (k<2*teamSize) {
	cout<<i<<"of"<<m<<" "<<k<<endl;
	ok=false;
	break;
      }
      for (j=0; j<2*teamSize; ++j) {
	do {
	  k=randInt();
	} while (u[k] || g[k]>=nOfGamesPerPlayer);
	u[k]=true;
	g[k]++;
	a[i][j]=k;  // inv # goes from 0 to POPULATION_SIZE-1 in this program
      }
    }
  } while (!ok);  
  for (i=0; i<m; ++i) {
    match(2*teamSize,a[i],i+1);
  }
}

int main(void) {
  f.open("experiment",ios::out|ios::trunc);
  srand((unsigned)time(NULL));
  int i, j;
  f<<"#! /bin/bash -x\n#\n";
  // Traps
  f<<"trap `exit; killall Team rcssserver` 2\n";
  // Definitions
  f<<"#\n#definitions...\n#\n";
  // function cpulog
  f<<"function cpulog {\n";
#define GREP(x) "`ps -o %cpu,args | grep "<<x<<" | grep -v grep | awk \'{print $1}\'`"
#define GREP2(x,y) "`ps -o %cpu,args | grep "<<x<<" | grep "<<y<<" | awk \'{print $1}\'`"
  if (goalie) {
    f<<"    echo -n "<<DATE<<"\"%cpu - Goalies + Server + Trainer: \" >>"<<logfile<<endl;
    f<<"    ja_sum "<<GREP("true")<<' '<<GREP("rcssserver")<<' '<<GREP("trainer")<<" >>"<<logfile<<endl;
  }
  else {
    f<<"    echo -n "<<DATE<<"\"%cpu - Server + Trainer: \" >>"<<logfile<<endl;
    f<<"    ja_sum "<<GREP("rcssserver")<<' '<<GREP("trainer")<<" >>"<<logfile<<endl;
  }
  f<<"    echo -n "<<DATE<<"\"%cpu - Team l: \" >>"<<logfile<<endl;
  f<<"    ja_sum "<<GREP2("$1","false")<<" >>"<<logfile<<endl;
  f<<"    echo -n "<<DATE<<"\"%cpu - Team r: \" >>"<<logfile<<endl;
  f<<"    ja_sum "<<GREP2("$2","false")<<" >>"<<logfile<<endl;
  f<<"}\n";
#undef GREP
#undef GREP2
  // function match
  f<<"function match {\n";
  f<<"    rm *.fit\n";
  f<<"    c=0\n";
  f<<"    while ! (";
  for (j=0; j<=1; ++j)
    for (i=1; i<=teamSize; ++i) {
      f<<"(test -a "<<(j?'r':'l')<<dec2hex(i,0)<<".fit)";
      if (j!=1 || i<teamSize)
	f<<" && ";
    }
  f<<") ; do\n";
  f<<"        if [ $c -eq 0 ] ; then\n";
  f<<"            echo \"Match $3\"\n";
  f<<"            "; LOG("Match $3 ($1 vs. $2)");
  f<<"        else\n";
  f<<"            echo \"Match $3 (rematch)\"\n";
  f<<"            "; LOG("Match $3-$c ($1 vs. $2)");
  f<<"        fi\n";
  f<<"        rcssserver -coach >>s.txt &\n";
  f<<"        sleep 2\n";
  f<<"        for j in $1 $2 ; do\n";
  f<<"            for ((i=1 ; i<="<<teamSize<<" ; i++)) ; do \n";
  f<<"                "<<player<<" -team_name $j >>p.txt &\n";
  f<<"                "<<connection_delay<<endl;
  f<<"            done\n";
  if (goalie) {
    f<<"            "<<goalkeeper<<" -team_name $j >>g.txt &\n";
    f<<"            "<<connection_delay<<endl;
  }
  f<<"        done\n";
  f<<"        "<<trainer<<" -match "<<game_length<<" >>t.txt &\n";
  f<<"        sleep "<<game_length-65<<endl;
  f<<"        cpulog $1 $2\n";
  f<<"        sleep 75\n";
  f<<"        killall Team >>k.txt\n";
  f<<"        killall rcssserver >>k.txt\n";
  f<<"        sleep 5\n";
  f<<"        c=`expr $c+1`\n";
  f<<"    done\n";
  f<<"    mv incomplete.rcg $(date +%Y%m%d%H%M%S)-$1-$2.rcg\n";
  f<<"    mv incomplete.rcl $(date +%Y%m%d%H%M%S)-$1-$2.rcl\n";
  f<<"    "<<eval_fitness<<" -load >>f.txt\n";
  f<<"    sleep 3\n";
  f<<"}\n";
  // function error
  f<<"function error {\n";
  f<<"    "; log("ERROR: $1");
  f<<"    cat "<<logfile<<endl;
  f<<"    exit\n";
  f<<"}\n";
  // function fileexists
  f<<"function fileexists {\n";
  f<<"    if ! (test -a $1) ; then\n";
  f<<"        error \"file_($1)_does_not_exist\"\n";
  f<<"    fi\n}\n";
  // Test if the script was started from "the ~/robocup/exp/ - script"
  f<<"#\n# Authorization...\n#\n";
  f<<"if [ $# -lt 1 ] || [ $1 -ne "<<AUTCODE<<" ] ; then\n";
  f<<"    error authorization\n";
  f<<"fi\n";
  // Test constants
  f<<"#\n# Test...\n#\n";
  f<<"if [ "<<(nOfPlayers*nOfGamesPerPlayer)%(teamSize*2)<<" -ne 0 ] ; then\n";
  f<<"    error parameters\n";
  f<<"fi\n";
  f<<"if [ "<<2*teamSize<<" -gt "<<nOfPlayers<<" ] ; then\n";
  f<<"    error parameters\n";
  f<<"fi\n";
  // Check if all programs exists
  f<<"fileexists "<<eval_fitness<<endl;
  f<<"fileexists "<<trainer<<endl;
  f<<"fileexists "<<evolver<<endl;
  f<<"fileexists "<<player<<endl;
  f<<"fileexists "<<goalkeeper<<endl;
  // Init experiment
  f<<"#\n# Init...\n#\n";
  f<<"cd "<<rundir<<endl;
  if (starting_gen == 0) {
    f<<"rm -rf *"<<endl;
    LOGCMD("cat "<<scdir<<"scconst.h | grep int | grep -v nOfPlayers | awk '{print $3 $4 $5}'");
    LOGCMD("cat "<<scdir<<"scconst.h | grep bool | awk '{print $3 $4 $5}'");
    LOG("nOfPlayers="<<nOfPlayers);
    LOG("creating a new population");
    f<<evolver<<" -new"<<endl;
    LOG("population created");
  }
  else {
    LOG("using existing population in gen.dat");
  }
  // The experiment
  f<<"#\n# Let us begin...\n#\n";
  for (i=starting_gen; i<starting_gen+nOfGenerations; ++i) {
    log("------------------------------");
    log("Main Loop - Entering loop #",i);
    log("------------------------------");
    f<<eval_fitness<<" -reset >>f.txt\n";
    tournament();
    LOG("determining fitness...");
    f<<eval_fitness<<" -calc >>f.txt\n";
    LOG("creating next generation...");
    f<<evolver<<" -evolve"<<endl;
    LOG("zipping *.dat *.rcl *.rcg, but not gen.dat")
    f<<"gzip *.dat *.rcl *.rcg \n";
    f<<"gunzip gen.dat.gz\n";
    LOG("making a new directory ("<<i<<") and moving *.gz *.txt to it");
    f<<"mkdir "<<i<<endl;
    f<<"mv *.gz *.txt "<<i<<"/\n";
    LOG("Exiting main loop...");
  }
  LOG("\n\nExperiment ended\n\nbye...");
  f.close();
  return 0;
}
