#include "command.h"
#include <iostream.h>
#include <string.h>

Command::Command(char* host, int port, bool printServerMessages) {
  bool ok=true;
  char initMessage[] = "(init (version 7.1))";
  udp = new UDPSocket();
  cout<<"Connecting to "<<host<<":"<<port<<" ... ";
  if (udp->initConnection(host,port)<0) {
    cout<<"failed\n";
    ok=false;
  }
  else {
    cout<<"ok\n";
  }
  if (ok) {
    if (udp->sendMessage(initMessage)>-1) {
      if (waitOnMessage(true)) {
        receiveMessage(printServerMessages);
        if (!strcmp(msg,"(init ok)")) {
          while (waitOnMessage(true))
            receiveMessage(printServerMessages);
        }
        else {
          ok = false;
        }
      }
      else
        ok = false;
    }
    else
      ok = false;
    if (!ok)
      cout<<"Failed to connect as a trainer\n";
  }
}

Command::~Command(void) {
  udp->sendMessage("(bye)");
  delete udp;
  cout<<"Connection to server terminated...\n";
}

bool Command::waitOnMessage(bool timeout) {
  int i;
  if (timeout) {
    i = 0;
    while (!udp->pollSocket() && i < 200000) ++i;
    if (i==200000)
      return false;
  }
  else 
     while (!udp->pollSocket()) ;
  return true;
}

void Command::startServer() {
  cout<<"Starting server\n";
  char startMsg[]="(start)";
  udp->sendMessage(startMsg);
}

void Command::stopMatch() {
  udp->sendMessage("(say bye)");
}

void Command::receiveMessage(bool print) {
  udp->receiveMessage(msg);
  if (print)
    cout << msg << endl;
}


