#include <iostream.h>
#include "command.h"

int main(int argc, char **argv) {
  char host[] = "localhost";
  int port = 6001, time;
  bool serverMessages = false;
  enum {START, STOP, MATCH, UNKNOWN} m = UNKNOWN;

  // Interpret arguments...
  char arg1[100], arg2[100];
  while (argc > 2) {
    strcpy(arg1,argv[argc-2]);
    strcpy(arg2,argv[argc-1]);
    argc-=2;
    if (!strcmp(arg1,"-match")) {
      m = MATCH;
      time = atoi(arg2);
    }
    else if (!strcmp(arg1,"-command")) {
      if (!strcmp(arg2,"start"))
	m = START;
      else if (!strcmp(arg2,"stop"))
	m = STOP;
    }
    else if (!strcmp(arg1,"-host")) {
      strcpy(host,arg2);
    }
    else if (!strcmp(arg1,"-port")) {
      port=atoi(arg2);
    }
    else if (!strcmp(arg1,"-enable") || !strcmp(arg1,"-disable")) {
      bool v = !strcmp(arg1,"-enable") ? true : false;
      if (!strcmp(arg2,"serverMessages"))
        serverMessages = v;
      else
        cout << "Unknown option after " << arg1 << ": " << arg2 << endl;
    }
    else {
      cout<<"Unknown argument: "<<arg1<<endl;
    }
  }
  
  Command* cmd = new Command(host,port,serverMessages); 
  if (m == START)
    cmd->startServer();
  else if (m == STOP)
    cmd->stopMatch();
  else if (m == MATCH) {
    cmd->startServer();
    sleep(time);
    cmd->stopMatch();
  }
  else
    cmd->startServer();
  delete cmd;
}
