/*
 * Definitions for UDP c/s program.
 */

#ifndef UDPSOCKETDEFINED
#define UDPSOCKETDEFINED

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <errno.h>
#include <time.h>

#ifdef Linux
#include <sys/time.h>
#endif

#define MAXMSG						1024
#define DEFAULT_PORT_NUMBER	6000

#ifdef MEMSET
#define bzero(a, b) memset(a, 0, b)
#endif

typedef struct socket {
	int socketfd;
	struct sockaddr_in serv_addr ;
}Socket;

class UDPSocket {
	Socket sock;
	FILE *fpin, *fpout;
	fd_set readfds, readfds_bak;
	struct timeval zerotime;
	char recbuf[MAXMSG];
	char sendbuf[MAXMSG];


public:
	UDPSocket( void );
	~UDPSocket( void );
	bool pollSocket( void );
	int initConnection( char* host, int port );
	int sendMessage( char* buf );
	int receiveMessage( char *buf );	
	void closeConnection();
};


#endif
